#include <stdio.h>
#include <Windows.h>
#include <process.h>
#include <conio.h>
#include "MvCameraControl.h"

bool g_bExit = false;
unsigned int g_nPayloadSize = 0;

// ch:ȴ | en:Wait for key press
void WaitForKeyPress(void)
{
    while(!_kbhit())
    {
        Sleep(10);
    }
    _getch();
}

bool PrintDeviceInfo(MV_CC_DEVICE_INFO* pstMVDevInfo)
{
    if (NULL == pstMVDevInfo)
    {
        printf("The Pointer of pstMVDevInfo is NULL!\n");
        return false;
    }
    if (pstMVDevInfo->nTLayerType == MV_GIGE_DEVICE)
    {
        int nIp1 = ((pstMVDevInfo->SpecialInfo.stGigEInfo.nCurrentIp & 0xff000000) >> 24);
        int nIp2 = ((pstMVDevInfo->SpecialInfo.stGigEInfo.nCurrentIp & 0x00ff0000) >> 16);
        int nIp3 = ((pstMVDevInfo->SpecialInfo.stGigEInfo.nCurrentIp & 0x0000ff00) >> 8);
        int nIp4 = (pstMVDevInfo->SpecialInfo.stGigEInfo.nCurrentIp & 0x000000ff);

        // ch:ӡǰipûԶ | en:print current ip and user defined name
        printf("CurrentIp: %d.%d.%d.%d\n" , nIp1, nIp2, nIp3, nIp4);
        printf("UserDefinedName: %s\n\n" , pstMVDevInfo->SpecialInfo.stGigEInfo.chUserDefinedName);
    }
    else if (pstMVDevInfo->nTLayerType == MV_USB_DEVICE)
    {
        printf("UserDefinedName: %s\n", pstMVDevInfo->SpecialInfo.stUsb3VInfo.chUserDefinedName);
        printf("Serial Number: %s\n", pstMVDevInfo->SpecialInfo.stUsb3VInfo.chSerialNumber);
        printf("Device Number: %d\n\n", pstMVDevInfo->SpecialInfo.stUsb3VInfo.nDeviceNumber);
    }
    else
    {
        printf("Not support.\n");
    }

    return true;
}

int readFile(const char *filename, char *buffer, int len)
{
	FILE *pfile = nullptr;
	int ret = fopen_s(&pfile, filename, "rb");

	int readlen = 0;
	/// 0 = 򿪳ɹ
	if (0 == ret)
	{
		if (pfile)
		{
			fseek(pfile, 0, SEEK_END);
			unsigned int file_length_bytes = ftell(pfile);
			fseek(pfile, 0, SEEK_SET);

			if(file_length_bytes>len) file_length_bytes = len;
			readlen = fread(buffer, 1, file_length_bytes, pfile);

			printf("ļɹ %d.\n", readlen);

			fclose(pfile);
			pfile = nullptr;
		}
		else
		{
			;/// pfile ļָΪnull
			printf("\n ļʧܣ pfile = null \n\n");
		}
	}
	else
	{
		;/// ʧ
		printf("\n ļʧܣļʧ\n\n");
	}
	return readlen;
}


int writeFile(const char *filenmae, char *buffer, int len)
{
	FILE *pfile = nullptr;
	int ret = fopen_s(&pfile, filenmae, "wb");

	int wrlength = 0;
	/// 0 = 򿪳ɹ
	if (0 == ret)
	{
		if (pfile)
		{
			/// дļ
			wrlength = fwrite(buffer, 1, len, pfile);
			fclose(pfile);
			pfile = nullptr;

			printf("\n дļɹ, д볤 %d\n", wrlength);
		}
		else
		{
			;/// pfile ļָΪnull
			printf("\n дļʧܣ pfile = null \n\n");
		}
	}
	else
	{
		;/// ʧ
		printf("\n дļʧܣļʧ\n\n");
	}
	return wrlength;
}


//ûдspi߼
//1WRITEMEM8512ֽڵİַΪ0x80000c00RAMռ䣬32bitλ1ʾramַgigevisionַһ4KB
//2WRITEREG0x05000600Ҫ浽spiַעַΧֻSpiAddrMinReg-SpiAddrMaxReg(8bit),Լ100msյackַΧյack1ms,ʧܣԼ134msյack

#define STORE_BASE_ADDR 0x400000  //ЧΧ0x400000-0x7FFFFF  4MByte
#define STORE_COMMAND 0x05000600
//storeToCam
//	д洢ռ
//	buffer  ݻ
//  len     ݳ, д洢Ҫ4096ֽڵ bufferҪ㹻Ŀռ
int storeToCam(void *handle, char *buffer, int len)
{
	int nRet = MV_OK;
	int count = len / 0x200 / 8;

	if(len%0x1000!=0) //4K
	{
		int fillcnt = 0x1000 - len%0x1000;
		memset(buffer+len, 0, fillcnt);
		count += 1;
	}
	for(int i=0; i<count; i++)
	{
		char *p = buffer + i*0x1000;
		for(int j=0; j<8; j++)
		{
			nRet = MV_CC_WriteMemory(handle, p+j*0x200, 0x80000c00+j*0x200/4, 0x200);
			if (MV_OK != nRet)
			{
				printf("WriteMemory fail! nRet [0x%x]\n", nRet);
			}
		}

		int addr = STORE_BASE_ADDR + i*0x1000;
		char addrb[4];  
		addrb[0] = (addr&0xff000000) >> 24;
		addrb[1] = (addr&0x00ff0000) >> 16;
		addrb[2] = (addr&0x0000ff00) >> 8;
		addrb[3] = (addr&0x000000ff) >> 0;
		nRet = MV_CC_WriteMemory(handle, addrb, STORE_COMMAND, 4);
		if (MV_OK != nRet)
		{
			printf("WriteMemory fail! nRet [0x%x]\n", nRet);
		}
		else
		{
			printf("Write part %d/%d\n",i+1,count);
		}
	}

	return count*0x1000;
}

//ûspi߼
//1WRITEREG0x05000604spiַspi4KBݶַΪ0x80000c00ramռ䣨32bitɹԼ2msʱյack,ȡspiɹʧܶյackʧϳʱյack
//2READMEM0x80000c00ramռ4KB
#define LOAD_COMMAND 0x05000604
//loadFromCam
//	洢ռȡ
//	buffer  ݻ
//  len     ݳ, ȡ洢Ҫ4096ֽڵ bufferҪ㹻Ŀռ
int loadFromCam(void *handle, char *buffer, int len)
{
	int nRet = MV_OK;
	int count = len / 0x200 / 8;

	if(len%0x1000!=0) //4K
	{
		count += 1;
	}
	memset(buffer, 0, count*0x1000);
	
	for(int i=0; i<count; i++)
	{
		int addr = STORE_BASE_ADDR + i*0x1000;
		char addrb[4];  
		addrb[0] = (addr&0xff000000) >> 24;
		addrb[1] = (addr&0x00ff0000) >> 16;
		addrb[2] = (addr&0x0000ff00) >> 8;
		addrb[3] = (addr&0x000000ff) >> 0;
		nRet = MV_CC_WriteMemory(handle, addrb, LOAD_COMMAND, 4);
		if (MV_OK != nRet)
		{
			printf("WriteMemory fail! nRet [0x%x]\n", nRet);
		}
		else
		{
			printf("Read part %d/%d\n",i+1,count);
		}

		char *p = buffer + i*0x1000;
		for(int j=0; j<8; j++)
		{
			nRet = MV_CC_ReadMemory(handle, p+j*0x200, 0x80000c00+j*0x200/4, 0x200);
			if (MV_OK != nRet)
			{
				printf("MV_CC_ReadMemory fail! nRet [0x%x]\n", nRet);
			}
		}
	}

	return count*0x1000;
}


int main()
{
    int nRet = MV_OK;
    void* handle = NULL;

    do 
    {
        // ch:ö豸 | en:Enum device
        MV_CC_DEVICE_INFO_LIST stDeviceList;
        memset(&stDeviceList, 0, sizeof(MV_CC_DEVICE_INFO_LIST));
        nRet = MV_CC_EnumDevices(MV_GIGE_DEVICE | MV_USB_DEVICE, &stDeviceList);
        if (MV_OK != nRet)
        {
            printf("Enum Devices fail! nRet [0x%x]\n", nRet);
            break;
        }

        if (stDeviceList.nDeviceNum > 0)
        {
            for (unsigned int i = 0; i < stDeviceList.nDeviceNum; i++)
            {
                printf("[device %d]:\n", i);
                MV_CC_DEVICE_INFO* pDeviceInfo = stDeviceList.pDeviceInfo[i];
                if (NULL == pDeviceInfo)
                {
                    break;
                } 
                PrintDeviceInfo(pDeviceInfo);            
            }  
        } 
        else
        {
            printf("Find No Devices!\n");
            break;
        }

        printf("Please Input camera index:");
        unsigned int nIndex = 0;
        scanf_s("%d", &nIndex);

        if (nIndex >= stDeviceList.nDeviceNum)
        {
            printf("Input error!\n");
            break;
        }

		printf("Action 0 store file param.bin, 1 read to file test.bin:");
        unsigned int nAction = 0;
        scanf_s("%d", &nAction);
		if(nAction!=0) nAction = 1;

        // ch:ѡ豸 | en:Select device and create handle
        nRet = MV_CC_CreateHandle(&handle, stDeviceList.pDeviceInfo[nIndex]);
        if (MV_OK != nRet)
        {
            printf("Create Handle fail! nRet [0x%x]\n", nRet);
            break;
        }

        // ch:豸 | en:Open device
        nRet = MV_CC_OpenDevice(handle);
        if (MV_OK != nRet)
        {
            printf("Open Device fail! nRet [0x%x]\n", nRet);
            break;
        }

		int bufferlen = 1024*1024*4;//4M max
		char *data1 = new char[bufferlen]; 
		char *data2 = new char[bufferlen]; 
		if(nAction==0)
		{
			int readlen = readFile("param.bin", data1, bufferlen);
			storeToCam(handle, data1, readlen);
		}
		else
		{
			int len = 2*1024*1024;
			int readlen = loadFromCam(handle, data2, len);
			writeFile("test.bin", data2, readlen);
		}

		delete [] data1;
		delete [] data2;

        // ch:ر豸 | Close device
        nRet = MV_CC_CloseDevice(handle);
        if (MV_OK != nRet)
        {
            printf("ClosDevice fail! nRet [0x%x]\n", nRet);
            break;
        }

        // ch:پ | Destroy handle
        nRet = MV_CC_DestroyHandle(handle);
        if (MV_OK != nRet)
        {
            printf("Destroy Handle fail! nRet [0x%x]\n", nRet);
            break;
        }
    } while (0);
    

    if (nRet != MV_OK)
    {
        if (handle != NULL)
        {
            MV_CC_DestroyHandle(handle);
            handle = NULL;
        }
    }

    printf("Press a key to exit.\n");
    WaitForKeyPress();

    return 0;
}
